// Definizione e testing una funzione che calcola il minimo comune
// multiplo tra 2 interi positivi

// inclusione dell'header file della libreria standard di
// definizioni di macro, costanti e dichiarazioni di funzioni e tipi
// per le varie operazioni di input/output

#include <stdio.h>

// definizione di una prima versione della funzione

int mcm_1 (int x, int y)
   // Parametri formali
   //    x, y:      valore dei quali voglio calcolare il minimo
   //               comune multiplo
   {
   // variabile per il candidato corrente    
   int candidato;
   
   // inizializzazione della variabile per il candidato corrente    
   candidato = 1;
   
   while (1)
      {
      // controllo se il candidato corrente è divisibile per entrambi i valori
      if (((candidato % x) == 0) && ((candidato % y) == 0))
	    // se è vero allora il candidato corrente e' il mcm
	    return(candidato);
      else
	    // altrimenti aggiorno il valore del candidato corrente
        candidato++;
	  }
   }

// definizione di una seconda versione della funzione
int mcm_2 (int x, int y)
   // Parametri formali
   //    x, y:      valore dei quali voglio calcolare il minimo
   //               comune multiplo
   {
   // definizione e inizializzazione di un moltiplicatore
   int molt = 1;
   
   // entro in un ciclo privo di condizione di uscita
   while(1)
      // controllo se il prodotto del primo valore per il moltiplicatore
      // e' divisibile per il secondo valore
      if (((x * molt) % y) == 0)
	    // se è vero allora il prodotto del primo valore per il
	    // moltiplicatore e' il mcm
	    return(x * molt);
      else
	    // altrimenti aggiorni il valore del moltiplicatore
        molt++;
   }

// definizione di una terza versione della funzione

int mcm_3 (int x, int y)
   // Parametri formali
   //    x, y:      valore dei quali voglio calcolare il minimo
   //               comune multiplo
   {
   // variabile per il candidato corrente    
   int candidato;
   
   // inizializzazione della variabile per il candidato corrente    
   candidato = 1;
   
   // controllo se il candidato corrente e' divisibile per entrambi i valori
   // Se e' vero esco dal while
   while (!(((candidato % x) == 0) && ((candidato % y) == 0)))
	  // altrimenti aggiorno il valore del candidato corrente
      candidato++;

   // il valore del candidato corrente, una volta usciti dal while, e' il mcm
   return(candidato);
   }
   
// Testing della funzione

int main()
   {
   // definizione delle variabile di input
   int a, b;

   // acquisisco il primo valore
   printf("\nDammi il primo valore: ");
   scanf("%d", &a);
   
   // acquisisco il secondo valore
   printf("\nDammi il secondo valore: ");
   scanf("%d", &b);
   
   // calcolo e restituisco il mcm
   printf ("Il mcm tra %d e %d e': %d", a, b, mcm_3 (a, b));
 
   return(0);
   }
